<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_DIRECT_PURCHASE_RETURN';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/purchasing/includes/ui/direct_purchase_returns_ui.inc");
include_once($path_to_root . "/purchasing/includes/db/quality_checks_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/project_cost_functions.inc"); 
include_once($path_to_root . "/includes/db/inventory_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/lot_allocations_db.inc");  
include_once($path_to_root . "/inventory/includes/ui/lot_ui.inc");  
include_once($path_to_root . "/inventory/includes/db/lots_db.inc");   
include_once($path_to_root . "/purchasing/includes/db/direct_purchase_requisitions_db.inc");   
include_once($path_to_root . "/includes/approval_functions.inc");

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if (isset($_GET['ProcessedID'])) {
    page(_($help_context = $systypes_array[ST_DIRECT_PURCHASE_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['ProcessedID'];
    $trans_type = $_GET['type'];
    
    $msg = get_session_variable('dp_rtn_messages');
    clear_session_variable('dp_rtn_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification_centered($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    page(_($help_context = $systypes_array[ST_DIRECT_PURCHASE_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('dp_rtn_bo_messages');
    clear_session_variable('dp_rtn_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['RejectedID'])) {
    page(_($help_context = $systypes_array[ST_DIRECT_PURCHASE_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('dp_rtn_rj_messages');
    clear_session_variable('dp_rtn_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if ((isset($_GET['rcp_no']) && is_numeric($_GET['rcp_no'])) || (isset($_POST['rcp_no']) && is_numeric($_POST['rcp_no']))) {
    $_POST['rcp_no'] = isset($_GET['rcp_no']) ? $_GET['rcp_no'] : $_POST['rcp_no'];
    
    $header = get_quality_check_header_record($_POST['rcp_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_DIRECT_PURCHASE_RECEIPT) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_DIRECT_PURCHASE_RECEIPT]." record #".$_POST['rcp_no']));
            display_footer_exit();
        }
    
    $page_title = _('New '.$systypes_array[ST_DIRECT_PURCHASE_RETURN]);
    
} elseif ((isset($_GET['rtn_no']) && is_numeric($_GET['rtn_no'])) || (isset($_POST['rtn_no']) && is_numeric($_POST['rtn_no']))) {
    $_POST['rtn_no'] = isset($_GET['rtn_no']) ? $_GET['rtn_no'] : $_POST['rtn_no'];
    
    $header = get_quality_check_header_record($_POST['rtn_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_DIRECT_PURCHASE_RETURN) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_DIRECT_PURCHASE_RETURN]." record #".$_POST['rtn_no']));
            display_footer_exit();
        }
        
    $_POST['rcp_no'] = $header['dpr_no'];
    $page_title = _('Modify '.$systypes_array[ST_DIRECT_PURCHASE_RETURN]." #".$header['trans_no'] );
    
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Could not find ".$systypes_array[ST_DIRECT_PURCHASE_RETURN]));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_POST['Process_RTN'])) {
    $msg = save_direct_purchase_returns($_POST['rcp_no'], $_POST['rtn_no'], true);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_RTN'])) {
    $msg = back_to_originator_direct_purchase_return($_POST['rcp_no'], $_POST['rtn_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['REJECT_RTN'])) {
    $msg = reject_direct_purchase_return($_POST['rcp_no'], $_POST['rtn_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Create_RTN'])) {        
    $msg = save_direct_purchase_returns($_POST['rcp_no'], $_POST['rtn_no']);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            $return_hd_row = get_quality_check_header_record($_POST['rtn_no']);
                if (! is_array($return_hd_row)) {
                    $rtn_no = $_POST['rtn_no'] = 0; 
                }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
        }
}

global $Ajax;

start_form();

    if (isset($_POST['rcp_no']) && $_POST['rcp_no'] > 0) {
        hidden('rcp_no', $_POST['rcp_no']);
    } else {
        $_POST['rcp_no'] = 0;
    }   
        
    if (isset($_POST['rtn_no']) && $_POST['rtn_no'] > 0) {
        hidden('rtn_no', $_POST['rtn_no']);
    } else {
        $_POST['rtn_no'] = 0;
    }

    $Ajax->activate('_page_body');
    $Ajax->activate('All_details');
    div_start('All_details');
    
        $rcp_hd_row = display_direct_purchase_receipt_header_details($_POST['rcp_no'], $_POST['rtn_no']);
        
        display_direct_purchase_return_header($_POST['rtn_no'], $rcp_hd_row);

        display_direct_purchase_return_details($_POST['rcp_no'], $_POST['rtn_no']);

            $header = get_quality_check_header($_POST['rtn_no']);
            if (is_array($header)) {
                submit_center_first('Create_RTN', _("Save  ".$systypes_array[ST_DIRECT_PURCHASE_RETURN]), '', 'default');    
                
                submit('Process_RTN', _("Process  ".$systypes_array[ST_DIRECT_PURCHASE_RETURN]), true, _("Process"), false, ICON_SUBMIT);
            
                submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT);                br(2);
                
                start_table();
                    submit_center_first('REJECT_RTN', _("Reject ".$systypes_array[ST_DIRECT_PURCHASE_RETURN]), '', true, ICON_DELETE);
                    
                    submit('BACK_TO_ORIGINATOR_RTN', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                end_table();
            } else {
                submit_center_first('Create_RTN', _("Create  ".$systypes_array[ST_DIRECT_PURCHASE_RETURN]), '', 'default');   
                
                submit('Refresh', 'Refresh', true, false, false, ICON_SUBMIT);
            }

    div_end();
    
end_form(2);
end_page(@$_GET['popup'], false, false);        

?>